from validators import mandatory, empty, iso_date, valid_iban, valid_bic


def test_mandatory():
    assert mandatory("Foo") == True
    assert mandatory("Foo Bar") == True
    assert mandatory("1970-01-01") == True
    assert mandatory("") == False
    assert mandatory(None) == False


def test_empty():
    assert empty(None) == True
    assert empty("") == True
    assert empty(" ") == False
    assert empty("Foo") == False
    assert empty("1970-01-01") == False


def test_iso_date():
    assert iso_date("1970-01-01") == True
    assert iso_date("1970-1-1") == True
    assert iso_date("70-01-01") == False
    assert iso_date("1970/01/01") == False
    assert iso_date("1.1.1970") == False
    assert iso_date("01.01.1970") == False
    assert iso_date("") == False
    assert iso_date(None) == False


def test_valid_iban():
    assert valid_iban("DE89 3704 0044 0532 0130 00") == True
    assert valid_iban("DE89370400440532013000") == True
    assert valid_iban("DX89 3704 0044 0532 0130 00") == False
    assert valid_iban("DE99 3704 0044 0532 0130 00") == False
    assert valid_iban("") == False
    assert valid_iban(None) == False
    assert valid_iban("DE89 3704 0044 0532 0130 00".split()) == False


def test_valid_bic():
    assert valid_bic("PBNKDEFFXXX") == True
    assert valid_bic("PBNKDXFFXXX") == False
    assert valid_bic("PBNKDXFFXXXX") == False
    assert valid_bic("PBN1DXFFXXX") == False
    assert valid_bic("") == False
    assert valid_bic(None) == False
    assert valid_bic("PBNKDEFFXXX".split()) == False


